/******************************************************************************
 *	wdialog.c:	EGCg_CAO̕\@
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 *
 *	@\:
 *	̃vÓAȃ_CAOłEGCg_CAO\T
 *	vłB
 *	Ԃ̂鏈sƂ́Aʏ}EX|C^҂Ԃ}EX
 *	|C^ɕςďs܂AłȂ莞Ԃ鏈s
 *	Ƃ̓EGCg_CAO\āAmɏsĂ邱Ƃgp
 *	҂ɒm点܂B
 *	EGCg_CAOp̊֐́ADMWaitOpenADMWaitWhileADMWaitClosêR
 *	܂B
 *	DMWaitOpenŃ_CAÕI[vi\jADMWaitOpenłQڈȍ~
 *	`ADMWaitCloseŃ_CAON[Y܂B
 *
 *	gp@:
 *	̃Tv́AEBhE[s]{^ƃEGCg_CAO
 *	\A؂̃Aj[VsPObɃN[Y܂B
 */
#include <ctype.h>
#include <stdlib.h>
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "wdialog.h"		/* ̃vOŗL̃wb_t@C	*/

char _sxkernelcomm[] = SXKERNEL;	/* J[lNR}h		*/

/******************************************************************************
 *	main():		C֐
 ******************************************************************************
 */
int main(void)
{
	ComVal cv;			/* ʕϐ			*/

	if (!init(&cv)) {		/* s		*/
		showErrDialog(&cv);	/* G[_CAO\	*/
		cv.endFlag = TRUE;	/* ItOZbg	*/
	}
	/* ItOZbg܂Ń[v */
	while (!cv.endFlag) {
		cv.errorCode = 0;	/* G[R[hNA	*/
		/* ^XN}Cxg擾 */
		TSEventAvail(cv.eventMask, &cv.event);
		/* eCxgɑΉs */
		switch (cv.event.ts.what) {
		case E_MSLDOWN:		/* }EXtg_ECxg	*/
			msLDownEvent(&cv);
			break;
		case E_KEYDOWN:		/* L[_ECxg		*/
			keyDownEvent(&cv);
			break;
		case E_UPDATE:		/* Abvf[gCxg		*/
			updateEvent(&cv);
			break;
		case E_ACTIVATE:	/* ANeBx[gCxg	*/
			activateEvent(&cv);
			break;
		case E_SYSTEM1:		/* VXeCxg		*/
		case E_SYSTEM2:
			systemEvent(&cv);
			break;
		}
		if (cv.errorCode != 0)	/* G[H		*/
			showErrDialog(&cv); /* G[_CAO\ */
	}
	/* I葱s */
	endProc(((cv.errorCode == 0) ? EXIT_SUCCESS : EXIT_FAILURE), &cv);

	return 0;
}

/******************************************************************************
 *	init():		
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: siIj
 *	:	ʕϐ̏AA{[g֐̓o^AEBhE̍쐬
 *		\ȂǂsB
 */
BOOLEAN init(ComVal *pcv)
{
	pcv->windowPtr = NULL;		/* EBhE|C^		*/
	pcv->activeFlag = FALSE;	/* ANeButO		*/
	pcv->eventMask = EVENTMASK;	/* Cxg}XN		*/
	pcv->errorCode = 0;		/* G[R[h			*/
	pcv->endFlag = FALSE;		/* ItO			*/
	pcv->chrBtnHdl = NULL;		/* {^̃Rg[nh */

	TSSetAbort(endProc, (long) pcv); /* A{[g֐o^	*/

	if (LOWWORD(SXVer()) < SXVER2) { /* rwVXẽo[W𒲂ׂ */
		pcv->errorCode = 1;	/* o[WQÂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	if (!createWindow(pcv)) {	/* EBhE쐬		*/
		pcv->errorCode = 2;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	GMSetGraph(&pcv->windowPtr->graph); /* JgOtɂ */
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɂ */
	/* obNOEhJ[CgO[ɂ */
	GMBackColor(G_LGRAY);

	if (!createControl(pcv)) {	/* Rg[쐬	*/
		pcv->errorCode = 3;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	WMShow(pcv->windowPtr);		/* EBhE\		*/
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	createWindow():	EBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createWindow(ComVal *pcv)
{
	int paramFlags;			/* p[^̗L		*/
	Rect rc;
	Task task;			/* ^XNǗR[h		*/

	static Rect winSize = { 0, 0, WIN_H, WIN_V }; /* EBhETCY */

	TSGetTdb(&task, TS_OWN);	/* ^XNǗR[h擾	*/
	paramFlags = TSTakeParam(	/* R}hC͂	*/
		task.command,		/* R}hC		*/
		&rc,			/* w肳ꂽEBhEʒu	*/
		NULL,			/* ŏIi[Ȃ	*/
		0,			/* AhXe[uۑȂ	*/
		NULL,			/* AhXe[u쐬Ȃ	*/
		NULL);			/* |C^mۂȂ		*/
	if (!(paramFlags & 1)) {	/* EBhEʒu̎w肪邩H */
		/* ȂꍇAVXeEBhE̍W擾 */
		rc = winSize;
		GMSlideRect(&rc, TSGetWindowPos());
	}

	pcv->windowPtr = WMOpen(	/* EBhEI[v	*/
		NULL,			/* EBhE|C^mۂ	*/
		&rc,			/* EBhE̕\ʒu		*/
		WINTITLE,		/* EBhE^Cg		*/
		FALSE,			/* I[vɕ`悵Ȃ	*/
		WI_STD2 << 4,		/* ^Cg̍LWEBhE	*/
		W_FRONT,		/* ԎOɕ\		*/
		TRUE,			/* N[Y{^gp	*/
		TSGetID());		/* ̃^XNhc		*/
	if (pcv->windowPtr == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	createControl():	Rg[̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createControl(ComVal *pcv)
{
	static Rect bounds = {		/* {^̈ʒuƑ傫	*/
		CHR_X, CHR_Y, CHR_X + CHRBTN_H + 12 * 2, CHR_Y + CHRBTN_V
	};

	pcv->chrBtnHdl = CMOpen(	/* {^쐬		*/
		pcv->windowPtr,		/* EBhE|C^		*/
		&bounds,		/* `悷ʒuƑ傫		*/
		(_LASCII)"\x04s",	/* {^̃^Cg		*/
		TRUE,			/* `拖tO		*/
		0,			/* Rg[̏l		*/
		0,			/* Rg[̍ŏl		*/
		1,			/* Rg[̍ől		*/
		CI_CHRBTN << 4,		/* {^̃\[Xhc~16	*/
		0);			/* [U[̏l		*/
	if (pcv->chrBtnHdl == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	msLDownEvent():	}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	EBhEŃ}EX̍{^ꂽꍇ̏sB
 *	̏ŃN[Y{^ɂIAEBhËړ\ƂȂ܂B
 */
void msLDownEvent(ComVal *pcv)
{
	int partCode;			/* EBhẼp[gR[h	*/
	Window *wTemp;			/* e|EBhE|C^	*/

	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		/* EBhECANeBuŁAOPT.1L[ĂȂH */
		if (!pcv->activeFlag && !(pcv->event.ev.how & KS_OPT1)) {
			/* EBhEANeBuɂ */
			WMSelect(pcv->windowPtr);
			/* {^ꂽꏊ̃p[gR[h擾 */
			partCode = WMFind(pcv->event.ev.where.x_y, &wTemp);
			/* ^Cgo[ȊOA{^ꂽH */
			if (partCode != W_INDRAG || !EMLStill())
				return;
		}
		/* }EX̃{^ĂԁAEBhE̊e폈
		   VXeɔCāA{^ꂽA܂͗ꂽꏊ
		   p[gR[h擾 */
		partCode = SXCallWindM(pcv->windowPtr, &pcv->event);
		switch (partCode) {
		case W_INCLOSE:		/* N[Y{^		*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
			break;
		case W_ININSIDE:	/* EBhE̓		*/
			checkControl(pcv); /* Rg[`FbN */
			break;
		}
	}
}

/******************************************************************************
 *	checkControl():	Rg[̃`FbN
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void checkControl(ComVal *pcv)
{
	int partCode;			/* Rg[̃p[gR[h	*/
	Control **ctrlHdl;		/* Rg[nh		*/

	/* }EX̃{^ĂԁARg[̊e폈VXe
	   CāARg[nhƃ{^ꂽA܂͗ꂽꏊ
	   ̃p[gR[h擾 */
	partCode = SXCallCtrlM(pcv->windowPtr, &pcv->event, 0, 0, NULL, &ctrlHdl);
	/* {^ŁAnhv */
	if (partCode == C_INBTTN && ctrlHdl == pcv->chrBtnHdl)
		showWaitDialog();	/* EGCg_CAO\ */
}

/******************************************************************************
 *	keyDownEvent():	L[_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	OPT.1+'Q'L[ł̏IsB
 */
void keyDownEvent(ComVal *pcv)
{
	int shortCut;			/* V[gJbgL[		*/

	if (pcv->event.ev.how & KS_OPT1) { /* OPT.1L[ꂽH	*/
		/* L[͂啶ɕϊ */
		shortCut = toupper((int) pcv->event.ev.whom.key.ascii);
		if (shortCut == 'Q')	/* IH			*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
	}
}

/******************************************************************************
 *	updateEvent():	Abvf[g
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	Abvf[gƂăEBhE`悷B
 *	̏sȂƁA艺̃EBhẼAbvf[gACh
 *	Cxg̏łȂȂ܂B
 */
void updateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		WMUpdate(pcv->windowPtr); /* Abvf[gJn	*/
		drawGraph(pcv);		/* EBhE`悷	*/
		WMUpdtOver(pcv->windowPtr); /* Abvf[gI	*/
	}
}

/******************************************************************************
 *	drawGraph():	EBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawGraph(ComVal *pcv)
{
	CMDraw(pcv->windowPtr);		/* ׂẴRg[`悷 */
}

/******************************************************************************
 *	activateEvent():	ANeBx[gCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	ANeBuACANeBuɂANeButO̐؂ւƁA
 *		Cxg}XN̐؂ւsB
 */
void activateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		pcv->activeFlag = TRUE;	/* ANeButOZbg	*/
		/* ANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK | EM_KEYDOWN;
	/* Cxg̃EBhEŁAANeBuԂH */
	} else if (pcv->activeFlag) {
		pcv->activeFlag = FALSE; /* ANeButONA */
		/* CANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK;
	}
}

/******************************************************************************
 *	systemEvent():	VXeCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	SEBhẼN[YAS^XN̏IAEBhẼZNg
 *		ΉsB
 */
void systemEvent(ComVal *pcv)
{
	switch (pcv->event.ts.what2) {	/* Cxg̎ނ́H		*/
	case CLOSEALL:			/* SEBhẼN[Y	*/
	case ENDTSK:			/* S^XN̏I		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		break;
	case WINDOWSELECT:		/* EBhẼZNg		*/
		WMSelect(pcv->windowPtr); /* EBhEANeBuɂ */
		break;
	}
}

/******************************************************************************
 *	showErrDialog():	G[_CAO̕\
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void showErrDialog(ComVal *pcv)
{
	int i;

	static struct {			/* G[			*/
		int code;		/* G[R[h			*/
		int manager;		/* gp}l[W		*/
		int flag;		/* \tbO			*/
		char *message;		/* G[bZ[W		*/
	} errInfo[] = {
		{ 1, 1, D_RED,    "SX SYSTEM̃o[WႢ܂B" },
		{ 2, 2, D_RED,    "EBhE쐬ł܂B" },
		{ 3, 2, D_RED,    "Rg[쐬ł܂B" },
		{ 0, 1, D_YELLOW, "G[܂B" }
	};

	for (i = 0; errInfo[i].code != 0; i++) /* G[R[h{	*/
		if (errInfo[i].code == pcv->errorCode)
			break;
	switch (errInfo[i].manager) {	/* }l[W̑I		*/
	case 1:				/* _CAO}		*/
		DMError(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	case 2:				/* ^XN}			*/
		TSErrDialogN(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	}
}

/******************************************************************************
 *	endProc():	I葱
 ******************************************************************************
 *	:	int code	IR[h
 *		ComVal *pcv	ʕϐւ̃|C^
 *	:	nh̉EBhE̔pƁAvȌIsB
 */
void endProc(int code, ComVal *pcv)
{
	/* EBhE|C^mۂꂽ܂܂H */
	if (pcv->windowPtr != NULL) {
		CMKill(pcv->windowPtr);	/* ׂẴRg[p */
		WMDispose(pcv->windowPtr); /* EBhEp	*/
	}

	exit(code);			/* vOI		*/
}

/******************************************************************************
 *	showWaitDialog():	EGCg_CAO̕\
 ******************************************************************************
 */
void showWaitDialog(void)
{
	int wtime;			/* ҂b			*/
	unsigned long ltime;		/* O񎞊			*/
	unsigned long ntime;		/* 񎞊			*/
	unsigned long interval;		/* |O			*/

	DMWaitOpen();			/* EGCg_CAOI[v */
	wtime = 0;			/* \b		*/
	ltime = EMSysTime();		/* ݂̃VXe擾	*/
	while (1) {
		ntime = EMSysTime();
		interval = ntime - ltime; /* ƑO̎Ԃ̍߂ */
		if (interval >= 100) {	/* PbȏソĂȂ	*/
			ltime = ntime;	/* Olꊷ		*/
			wtime++;	/* \bXV			*/
			if (wtime >= 10) { /* PObȂ */
				DMWaitClose(); /* _CAON[Y */
				break;	/* [v𔲂		*/
			} else
				DMWaitWhile(); /* _CAO̕`	*/
		}
	}
}
